package org.alive.tools.socketmessage;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Map;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;

/**
 * <p>̵̨߳øUI࣬ṩͨõUI»ƣҲڽϺ̨UIƺʹ¼ƻõ?
 * նUIĸҲǷŵEDTִ߳С</p>
 * 
 * <p>ע߳ͬʱͬһUIUpdaterʵregisterupdate߳ͬ⡣
 * WorkerTaskReadMessageTask߳ͬʱregisterͬʱuiMapʱͻͬ⡣</p>
 * 
 * <p>ûuiMapķնEDT߳УҲͲҪ߳ͬˡ</p>
 * 
 * @author XUHAILIN730
 * 
 */
public class UIUpdater {

	private static Map<Class<? extends JComponent>, Item> COMPONENT_MAP = new HashMap<Class<? extends JComponent>, Item>();

	// TODO: JComponent
	static {
		COMPONENT_MAP.put(JTextField.class, new Item("setText",
				new Class[] { String.class }));
		COMPONENT_MAP.put(JLabel.class, new Item("setText",
				new Class[] { String.class }));
		COMPONENT_MAP.put(JTextArea.class, new Item("setText",
				new Class[] { String.class }));
	}

	private Map<String, JComponent> uiMap = new HashMap<String, JComponent>();

	/**
	 * עҪʹUIUpdaterиµUI component
	 * 
	 * @param name
	 * @param component
	 */
	public void register(String name, JComponent component) {
		uiMap.put(name, component);
	}

	/**
	 * UIؼֵ
	 * 
	 * @param name
	 * @param values
	 */
	public void update(String name, Object[] values) {
		final String fName = name;
		final Object[] fValue = values;
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				JComponent component = uiMap.get(fName);
				if (component == null) {
					return;
				}
				Item item = COMPONENT_MAP.get(component.getClass());

				try {
					Method m = component.getClass().getMethod(item.methodName,
							item.parameterTypes);
					m.invoke(component, fValue);
				} catch (SecurityException e) {
					e.printStackTrace();
				} catch (NoSuchMethodException e) {
					e.printStackTrace();
				} catch (IllegalArgumentException e) {
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					e.printStackTrace();
				} catch (InvocationTargetException e) {
					e.printStackTrace();
				}
			}
		});
	}

	static class Item {
		String methodName;
		Class<?>[] parameterTypes;

		public Item(String methodName, Class<?>[] parameterTypes) {
			super();
			this.methodName = methodName;
			this.parameterTypes = parameterTypes;
		}
	}
}
